<template>
  <v-scroll-y-reverse-transition leave-absolute>
    <v-chip
      v-if="value === BookingStatus.BOOKED"
      prepend-icon="mdi-calendar-lock"
      class="text-amber-600"
      :size="size"
      :link="editable"
    >
      <span>Забронирован</span>

      <v-menu
        v-if="editable"
        location="bottom start"
        transition="scroll-y-transition"
        activator="parent"
      >
        <Container
          class="my-2 drop-shadow-md shadow-none overflow-hidden"
          reset-paddings
        >
          <v-list-item
            v-if="value === BookingStatus.BOOKED"
            v-tooltip:bottom="{ text: 'Нажмите, чтобы изменить статус', openOnClick: true }"
            class="py-2"
            link
            @click="$emit('update', BookingStatus.ACTIVE)"
          >
            <template #prepend>
              <span class="mr-1">
                <v-icon
                  icon="mdi-arrow-right-bottom"
                  class="text-gray-400"
                />
              </span>
            </template>

            <template #title>
              <v-chip
                prepend-icon="mdi-calendar-account"
                class="text-teal-500"
                text="Активный"
                size="large"
              />
            </template>
          </v-list-item>
        </Container>
      </v-menu>
    </v-chip>

    <v-chip
      v-else-if="value === BookingStatus.ACTIVE"
      prepend-icon="mdi-calendar-account"
      class="text-teal-500"
      :size="size"
      :link="editable"
    >
      <span>Активный</span>

      <v-menu
        v-if="editable"
        location="bottom start"
        transition="scroll-y-transition"
        activator="parent"
      >
        <Container
          class="my-2 drop-shadow-md shadow-none overflow-hidden"
          reset-paddings
        >
          <v-list
            class="p-0"
            slim
          >
            <v-list-item
              v-if="value === BookingStatus.ACTIVE"
              v-tooltip:bottom="{ text: 'Нажмите, чтобы изменить статус', openOnClick: true }"
              class="py-2"
              link
              @click="$emit('update', BookingStatus.DONE)"
            >
              <template #prepend>
                <span class="mr-1">
                  <v-icon
                    icon="mdi-arrow-right-bottom"
                    class="text-gray-400"
                  />
                </span>
              </template>

              <template #title>
                <v-chip
                  prepend-icon="mdi-calendar-check"
                  class="text-blue-500"
                  text="Завершен"
                  size="large"
                />
              </template>
            </v-list-item>
          </v-list>
        </Container>
      </v-menu>
    </v-chip>

    <v-chip
      v-else-if="value === BookingStatus.DONE"
      prepend-icon="mdi-calendar-check"
      class="text-blue-500 select-none cursor-default"
      text="Завершен"
      :size="size"
    />

    <v-chip
      v-else-if="value === BookingStatus.CANCELLED"
      prepend-icon="mdi-calendar-remove"
      class="text-red-500 select-none cursor-default"
      text="Отменен"
      :size="size"
    />

    <v-chip
      v-else
      prepend-icon="mdi-help"
      class="text-gray-500 select-none cursor-default"
      text="Неизвестный"
      :size="size"
    />
  </v-scroll-y-reverse-transition>
</template>

<script setup lang="ts">
import { BookingStatus } from '@/declarations';

import Container from '@/components/layout/Container.vue';

type BookingStatusDisplayProps = {
  value: BookingStatus;
  size?: 'small' | 'default' | 'large';
  editable?: boolean;
}

defineEmits(['update']);
withDefaults(defineProps<BookingStatusDisplayProps>(), {
  size: 'default',
  editable: false,
});
</script>